/* Copyright and licensing: see the license block at the start of multiscrollOverlay.xul */

function Multiscroll() { 
	var defaults = Multiscroll.defaultPrefs;
	this.action = {
		initial : new Multiscroll.Action(new defaults.action.initial.tool(this), defaults.action.initial.settings),
		left : new Multiscroll.Action(new defaults.action.left.tool(this), defaults.action.left.settings),
		middle : new Multiscroll.Action(new defaults.action.middle.tool(this), defaults.action.middle.settings),
		right : new Multiscroll.Action(new defaults.action.right.tool(this), defaults.action.right.settings),
	};
	this.actionByButton getter= function() {
		return [this.action.left, this.action.middle, this.action.right];
	};
	
	this.event = new Multiscroll.Event(this, defaults);
	
	this.getActiveTool = function() {
		var index;
		for (index in this.action)
			if (this.action[index].tool.active)
				return this.action[index].tool;
		return this.none;
	}
	this.tool = {
		newByCode : function(value, pass) {
			return value == 0 ? new Multiscroll.Tool.Scroll(pass)
				: value == 3 ? new Multiscroll.Tool.Pan(pass)
				: value == 4 ? new Multiscroll.Tool.Drag(pass)
				: new Multiscroll.Tool.None(pass);
		},
		code : function(tool) {
			return tool instanceof Multiscroll.Tool.Scroll ? 0
				: tool instanceof Multiscroll.Tool.Pan ? 3
				: tool instanceof Multiscroll.Tool.Drag ? 4
				: -1;
		}
	};
	
	this.prefsObserver = new Multiscroll.PrefsObserver(this);
	this.preferences = new Multiscroll.Preferences(this);
	
	this.none = new Multiscroll.Tool.None(this);
};

Multiscroll.mouse = {
	button : {
		left : 0, middle : 1, right : 2,
	},
	action : {
		mousedown : 0, click : 1, doubleclick : 2, release : 3, drag : 4
	}
};